package org.eclipse.epsilon.mwe;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import org.eclipse.epsilon.eol.exceptions.EolRuntimeException;
import org.eclipse.epsilon.eol.models.ModelRepository;
import org.eclipse.epsilon.eol.models.java.JavaModel;
import org.eclipse.epsilon.etl.EtlModule;
import org.eclipse.epsilon.mwe.model.MySource;
import org.eclipse.epsilon.mwe.model.MyTarget;

public class EtlTest {

    public static void main(String[] args) {

        // load and parse ETL module
        EtlModule etlModule = new EtlModule();
        try {
            etlModule.parse(EtlTest.class.getResource("TransformTest.etl").toURI());
        } catch (Exception e) {
            e.printStackTrace();
        }

        // source and target models
        ModelRepository repository = etlModule.getContext().getModelRepository();

        Collection<Object> objects = Collections.singletonList(new MySource());
        Collection<Class<?>> classes = Collections.singletonList(MySource.class);
        JavaModel javaModel = new JavaModel("Origin", objects, classes);
        repository.addModel(javaModel);

        objects = new ArrayList<Object>();
        classes = Collections.singletonList(MyTarget.class);
        javaModel = new JavaModel("Destination", objects, classes);
        repository.addModel(javaModel);

        try {
            // try it!
            etlModule.execute();
        } catch (EolRuntimeException e) {
            // unfortunately we will get here
            e.printStackTrace();
        }
    }
}
